//+------------------------------------------------------------------+
#property copyright "Copyright  2011,"
#include <stdlib.mqh>

#define SIGNAL_NONE        0 
#define UP                 1 
#define DOWN               2
#define SIGNAL_BUY         3 
#define SIGNAL_SELL        4 
#define SIGNAL_CLOSEBUY    5
#define SIGNAL_CLOSESELL   6 
#define NONE               7 

extern string    separator1 = "------trend settings------";
extern int       barsInTrend = 1;                  // how many bars should be in trend

extern string    separator1a = "------Trading Time settings------";
extern bool      AllowTradesByTime = false;         // Trading Time Allowed
extern int       Start_Time = 2;                   // Time to allow trading to start ( hours of 24 hr clock ) 0 for both disables
extern int       Finish_Time = 17;                 // Time to stop trading ( hours of 24 hr clock ) 0 for both disables

extern string    separator2 = "------position settings------";
extern double    Buylots = 0.01;                     // fixed lot size
extern double    Selllots = 0.01;                     // fixed lot size
extern int       BuymaxTrades = 1;                   // max trades allowed for pyramiding
extern int       SellmaxTrades = 1;                   // max trades allowed for pyramiding
extern double    _stop_loss = 0;                   // stop loss
extern double    _take_profitT = 0;                // take profit
extern double    _take_profit = 0;                // take profit
extern bool      useTrailingStop = True;          // use trailing stop
extern double    trailing_stop = 35;               // trail stop loss
extern bool      useUnprofitExit = True;          // exit trade when trade was not in profit in defined amount of bars
extern int       maxUnprofitBars = 5;              // amount of bars not in profit
extern string    _symb;
extern bool	PopupAlert        	= true;
extern bool SendPushNotification = false;
extern bool SoundAlert           = false;
extern string SoundFileLong      = "alert.wav";
extern string SoundFileShort     = "alert2.wav";
int lastAlert=3;
 
extern string    separator4 = "------Sleep settings------";
extern bool      useSleepAfterClosed = False;       // Put to sleep for 30 minit after closing order

extern double    magicNumber = 0;

double _stopLoss, _takeProfitT, takeProfit, trailingStop;
int             MyPoint=1;

bool buyBE, sellBE;
bool TrendOpen, TrendClosed;
bool EntryBuy, EntrySell;

double signal_Buy1;
double signal_Buy2;
double signal_Buy3;
double signal_Sell1;
double signal_Sell2;
double signal_Sell3;

double minAllowedLot, lotStep, maxAllowedLot;

int unprofitBars=0;
int Order = SIGNAL_NONE;
int slipageOrder = 3, slipageClose = 5;

double pips2dbl;
datetime barTime=0;
static datetime barTimeM5; 

int flag, count;
bool dselect,dclosed,dmodify;

string GV_euraud, GV_eurnzd, GV_eurjpy, GV_eurusd, GV_eurcad;
string GV_gbpaud, GV_gbpnzd, GV_gbpjpy, GV_gbpusd, GV_gbpcad;
string GV_audusd, GV_nzdusd, GV_usdcad, GV_audjpy, GV_nzdjpy, GV_cadjpy;

int gv_euraud, gv_eurnzd, gv_eurjpy, gv_eurusd, gv_eurcad;
int gv_gbpaud, gv_gbpnzd, gv_gbpjpy, gv_gbpusd, gv_gbpcad;
int gv_audusd, gv_nzdusd, gv_usdcad, gv_audjpy, gv_nzdjpy, gv_cadjpy;

string GVTA_euraud, GVTA_eurnzd, GVTA_eurjpy, GVTA_eurusd, GVTA_eurcad;
string GVTA_gbpaud, GVTA_gbpnzd, GVTA_gbpjpy, GVTA_gbpusd, GVTA_gbpcad;
string GVTA_audusd, GVTA_nzdusd, GVTA_usdcad, GVTA_audjpy, GVTA_nzdjpy, GVTA_cadjpy;

int gvta_euraud, gvta_eurnzd, gvta_eurjpy, gvta_eurusd, gvta_eurcad;
int gvta_gbpaud, gvta_gbpnzd, gvta_gbpjpy, gvta_gbpusd, gvta_gbpcad;
int gvta_audusd, gvta_nzdusd, gvta_usdcad, gvta_audjpy, gvta_nzdjpy, gvta_cadjpy;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   //Comment("Copyright  2011");
   
  
  if(MarketInfo(_symb,MODE_DIGITS)==3||MarketInfo(_symb,MODE_DIGITS)==5)MyPoint=10; else MyPoint=1; 

   if (Digits == 5 || Digits == 3)    // Adjust for five (5) digit brokers.
   {            
      pips2dbl = Point*10;
   } 
   else 
   {    
      pips2dbl = Point;   
   }
   
   _stopLoss       = pips2dbl*_stop_loss;
   takeProfit    = pips2dbl*_take_profit;
   trailingStop   = pips2dbl*trailing_stop;
//------------------------------

if (!GlobalVariableCheck("GV_euraud")) GlobalVariableSet("GV_euraud",0);
if (!GlobalVariableCheck("GV_eurnzd")) GlobalVariableSet("GV_eurnzd",0);
if (!GlobalVariableCheck("GV_eurusd")) GlobalVariableSet("GV_eurusd",0);
if (!GlobalVariableCheck("GV_eurjpy")) GlobalVariableSet("GV_eurjpy",0);
if (!GlobalVariableCheck("GV_gbpaud")) GlobalVariableSet("GV_gbpaud",0);
if (!GlobalVariableCheck("GV_gbpnzd")) GlobalVariableSet("GV_gbpnzd",0);
if (!GlobalVariableCheck("GV_gbpusd")) GlobalVariableSet("GV_gbpusd",0);
if (!GlobalVariableCheck("GV_gbpjpy")) GlobalVariableSet("GV_gbpjpy",0);

if (!GlobalVariableCheck("GV_audusd")) GlobalVariableSet("GV_audusd",0);
if (!GlobalVariableCheck("GV_nzdusd")) GlobalVariableSet("GV_nzdusd",0);
if (!GlobalVariableCheck("GV_usdcad")) GlobalVariableSet("GV_usdcad",0);
if (!GlobalVariableCheck("GV_audjpy")) GlobalVariableSet("GV_audjpy",0);
if (!GlobalVariableCheck("GV_nzdjpy")) GlobalVariableSet("GV_nzdjpy",0);
if (!GlobalVariableCheck("GV_cadjpy")) GlobalVariableSet("GV_cadjpy",0);

if (!GlobalVariableCheck("GVTA_euraud")) GlobalVariableSet("GVTA_euraud",0);
if (!GlobalVariableCheck("GVTA_eurnzd")) GlobalVariableSet("GVTA_eurnzd",0);
if (!GlobalVariableCheck("GVTA_eurusd")) GlobalVariableSet("GVTA_eurusd",0);
if (!GlobalVariableCheck("GVTA_eurjpy")) GlobalVariableSet("GVTA_eurjpy",0);
if (!GlobalVariableCheck("GVTA_gbpaud")) GlobalVariableSet("GVTA_gbpaud",0);
if (!GlobalVariableCheck("GVTA_gbpnzd")) GlobalVariableSet("GVTA_gbpnzd",0);
if (!GlobalVariableCheck("GVTA_gbpusd")) GlobalVariableSet("GVTA_gbpusd",0);
if (!GlobalVariableCheck("GVTA_gbpjpy")) GlobalVariableSet("GVTA_gbpjpy",0);

if (!GlobalVariableCheck("GVTA_audusd")) GlobalVariableSet("GVTA_audusd",0);
if (!GlobalVariableCheck("GVTA_nzdusd")) GlobalVariableSet("GVTA_audusd",0);
if (!GlobalVariableCheck("GVTA_usdcad")) GlobalVariableSet("GVTA_usdcad",0);
if (!GlobalVariableCheck("GVTA_audjpy")) GlobalVariableSet("GVTA_audjpy",0);
if (!GlobalVariableCheck("GVTA_nzdjpy")) GlobalVariableSet("GVTA_nzdjpy",0);
if (!GlobalVariableCheck("GVTA_cadjpy")) GlobalVariableSet("GVTA_cadjpy",0);

/*   
   minAllowedLot  =  MarketInfo(Symbol(), MODE_MINLOT);    //IBFX= 0.10
   lotStep        =  MarketInfo(Symbol(), MODE_LOTSTEP);   //IBFX= 0.01
   maxAllowedLot  =  MarketInfo(Symbol(), MODE_MAXLOT );   //IBFX=50.00
   
   if(Selllots < minAllowedLot)
      Selllots = minAllowedLot;
   if(Buylots > maxAllowedLot)
      Buylots = maxAllowedLot;
*/

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment ("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()

{
//----
   if(IsNewBar())
   {
      if(IsProfitOnBar())
         unprofitBars=0;
      else
         unprofitBars++;
   }

   if(useTrailingStop)
      if(!TrailingStopCheck())
         return(0);
           
//-------------------------------------------
/*
datetime now = TimeCurrent(),
         tM5= now - now % 300;
if (barTimeM5 == tM5) return; barTimeM5 = tM5;
// start of a new M30 bar.
*/
//---------------------------------------------------------------------------------------++
// Get calculation for Main Pair
   string Cond_GBPAUD = "", Cond_GBPNZD = "", Cond_GBPUSD = "", Cond_GBPJPY = "", Cond_GBPCAD = "";
   string Cond_EURAUD = "", Cond_EURNZD = "", Cond_EURUSD = "", Cond_EURJPY = "", Cond_EURCAD = "";
   string Cond_AUDUSD = "", Cond_NZDUSD = "", Cond_AUDJPY = "", Cond_NZDJPY = "";
   string Cond_USDCAD = "", Cond_CADJPY = "";

    gv_euraud = GlobalVariableGet( "GV_euraud");
    gv_eurnzd = GlobalVariableGet( "GV_eurnzd");
    gv_eurusd = GlobalVariableGet( "GV_eurusd");
    gv_eurjpy = GlobalVariableGet( "GV_eurjpy");
    gv_eurcad = GlobalVariableGet( "GV_eurcad");
    gv_gbpaud = GlobalVariableGet( "GV_gbpaud");
    gv_gbpnzd = GlobalVariableGet( "GV_gbpnzd");
    gv_gbpusd = GlobalVariableGet( "GV_gbpusd");
    gv_gbpjpy = GlobalVariableGet( "GV_gbpjpy");
    gv_gbpcad = GlobalVariableGet( "GV_gbpcad");

    gv_audusd = GlobalVariableGet( "GV_audusd");
    gv_nzdusd = GlobalVariableGet( "GV_nzdusd");
    gv_audjpy = GlobalVariableGet( "GV_audjpy");
    gv_nzdjpy = GlobalVariableGet( "GV_nzdjpy");
    gv_usdcad = GlobalVariableGet( "GV_usdcad");
    gv_cadjpy = GlobalVariableGet( "GV_cadjpy");

    gvta_euraud = GlobalVariableGet( "GVTA_euraud");
    gvta_eurnzd = GlobalVariableGet( "GVTA_eurnzd");
    gvta_eurusd = GlobalVariableGet( "GVTA_eurusd");
    gvta_eurjpy = GlobalVariableGet( "GVTA_eurjpy");
    gvta_eurcad = GlobalVariableGet( "GVTA_eurcad");
    gvta_gbpaud = GlobalVariableGet( "GVTA_gbpaud");
    gvta_gbpnzd = GlobalVariableGet( "GVTA_gbpnzd");
    gvta_gbpusd = GlobalVariableGet( "GVTA_gbpusd");
    gvta_gbpjpy = GlobalVariableGet( "GVTA_gbpjpy");
    gvta_gbpcad = GlobalVariableGet( "GVTA_gbpcad");

    gvta_audusd = GlobalVariableGet( "GVTA_audusd");
    gvta_nzdusd = GlobalVariableGet( "GVTA_nzdusd");
    gvta_audjpy = GlobalVariableGet( "GVTA_audjpy");
    gvta_nzdjpy = GlobalVariableGet( "GVTA_nzdjpy");
    gvta_usdcad = GlobalVariableGet( "GVTA_usdcad");
    gvta_cadjpy = GlobalVariableGet( "GVTA_cadjpy");

//-----------------------
// Calculate TRENDING FOR THE PAST 15 MINUTES --------------

         
///////////////////////////////VERIABLE BUY CONDITON ///////////////////////////////////////////////////////////////////
         if (gv_gbpusd > 0 && gvta_gbpusd > 0)
         {
         Cond_GBPUSD = "Condition GBPUSD BUY";
         CloseOrderCheck("GBPUSD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("GBPUSD",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_gbpusd < 0 && gvta_gbpusd < 0)
         {
         Cond_GBPUSD = "Condition GBPUSD SELL";
         CloseOrderCheck("GBPUSD",OP_BUY,Buylots, slipageOrder);
         ManageSell("GBPUSD",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_GBPUSD = "Condition GBPUSD NO TRADE";}

//----------------------------         
         if (gv_gbpjpy > 0 && gvta_gbpjpy > 0)
         {
         Cond_GBPJPY = "Condition GBPJPY BUY";
         CloseOrderCheck("GBPJPY",OP_SELL,Buylots, slipageOrder);
         ManageBuy("GBPJPY",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_gbpjpy < 0 && gvta_gbpjpy < 0)
         {
         Cond_GBPJPY = "Condition GBPJPY SELL";
         CloseOrderCheck("GBPJPY",OP_BUY,Buylots, slipageOrder);
         ManageSell("GBPJPY",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_GBPJPY = "Condition GBPJPY NO TRADE";}
         
//----------------------------         
         
         if (gv_gbpaud > 0 && gvta_gbpaud > 0)
         {
         Cond_GBPAUD = "Condition GBPAUD BUY";
         CloseOrderCheck("GBPAUD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("GBPAUD",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_gbpaud < 0 && gvta_gbpaud < 0)
         {
         Cond_GBPAUD = "Condition GBPAUD SELL";
         CloseOrderCheck("GBPAUD",OP_BUY,Buylots, slipageOrder);
         ManageSell("GBPAUD",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_GBPAUD = "Condition GBPAUD NO TRADE";}

//----------------------------         
         
         if (gv_gbpnzd > 0 && gvta_gbpnzd > 0)
         {
         Cond_GBPNZD = "Condition GBPNZD BUY";
         CloseOrderCheck("GBPNZD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("GBPNZD",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_gbpnzd < 0 && gvta_gbpnzd < 0)
         {
         Cond_GBPNZD = "Condition GBPNZD SELL";
         CloseOrderCheck("GBPNZD",OP_BUY,Buylots, slipageOrder);
         ManageSell("GBPNZD",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_GBPNZD = "Condition GBPNZD NO TRADE";}
         
 //-----------------------------         
         if (gv_gbpcad > 0 && gvta_gbpcad > 0)
         {
         Cond_GBPCAD = "Condition GBPCAD BUY";
         CloseOrderCheck("GBPCAD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("GBPCAD",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         } 
         else if (gv_gbpcad < 0 && gvta_gbpcad < 0)
         {
         Cond_GBPCAD = "Condition GBPCAD SELL";
         CloseOrderCheck("GBPCAD",OP_BUY,Buylots, slipageOrder);
         ManageSell("GBPCAD",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_GBPCAD = "Condition GBPCAD NO TRADE";}

//-------------------------------   
         if (gv_eurusd > 0 && gvta_eurusd > 0)
         {
         Cond_EURUSD = "Condition EURUSD BUY";
         CloseOrderCheck("EURUSD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("EURUSD",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_eurusd < 0 && gvta_eurusd < 0)
         {
         Cond_EURUSD = "Condition EURUSD SELL";
         CloseOrderCheck("EURUSD",OP_BUY,Buylots, slipageOrder);
         ManageSell("EURUSD",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_EURUSD = "Condition EURUSD NO TRADE";}    
//-------------------------------   
         if (gv_eurjpy > 0 && gvta_eurjpy > 0)
         {
         Cond_EURJPY = "Condition EURJPY BUY";
         CloseOrderCheck("EURJPY",OP_SELL,Buylots, slipageOrder);
         ManageBuy("EURJPY",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_eurjpy < 0 && gvta_eurjpy < 0)
         {
         Cond_EURJPY = "Condition EURJPY SELL";
         CloseOrderCheck("EURJPY",OP_BUY,Buylots, slipageOrder);
         ManageSell("EURJPY",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_EURJPY = "Condition EURJPY NO TRADE";}    
//-------------------------------   

         if (gv_euraud > 0 && gvta_euraud > 0)
         {
         Cond_EURAUD = "Condition EURAUD BUY";
         CloseOrderCheck("EURAUD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("EURAUD",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_euraud < 0 && gvta_euraud < 0)
         {
         Cond_EURAUD = "Condition EURAUD SELL";
         CloseOrderCheck("EURAUD",OP_BUY,Buylots, slipageOrder);
         ManageSell("EURAUD",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_EURAUD = "Condition EURAUD NO TRADE";}
         
//-------------------------------   
         if (gv_eurnzd > 0 && gvta_eurnzd > 0)
         {
         Cond_EURNZD = "Condition EURNZD BUY";
         CloseOrderCheck("EURNZD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("EURNZD",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_eurnzd < 0 && gvta_eurnzd < 0)
         {
         Cond_EURNZD = "Condition EURNZD SELL";
         CloseOrderCheck("EURNZD",OP_BUY,Buylots, slipageOrder);
         ManageSell("EURNZD",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_EURNZD = "Condition EURNZD NO TRADE";}
//-------------------------------   
         if (gv_eurcad > 0 && gvta_eurcad > 0)
         {
         Cond_EURCAD = "Condition EURCAD BUY";
         CloseOrderCheck("EURCAD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("EURCAD",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_eurcad < 0 && gvta_eurcad < 0)
         {
         Cond_EURCAD = "Condition EURCAD SELL";
         CloseOrderCheck("EURCAD",OP_BUY,Buylots, slipageOrder);
         ManageSell("EURCAD",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_EURCAD = "Condition EURCAD NO TRADE";}

//-------------------------------   
         if (gv_audusd > 0 && gvta_audusd > 0)
         {
         Cond_AUDUSD = "Condition AUDUSD BUY";
         CloseOrderCheck("AUDUSD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("AUDUSD",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_audusd < 0 && gvta_audusd < 0)
         {
         Cond_AUDUSD = "Condition AUDUSD SELL";
         CloseOrderCheck("AUDUSD",OP_BUY,Buylots, slipageOrder);
         ManageSell("AUDUSD",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_AUDUSD = "Condition AUDUSD NO TRADE";}

//-------------------------------   
         if (gv_nzdusd > 0 && gvta_nzdusd > 0)
         {
         Cond_NZDUSD = "Condition NZDUSD BUY";
         CloseOrderCheck("NZDUSD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("NZDUSD",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_nzdusd < 0 && gvta_nzdusd < 0)
         {
         Cond_NZDUSD = "Condition NZDUSD SELL";
         CloseOrderCheck("NZDUSD",OP_BUY,Buylots, slipageOrder);
         ManageSell("NZDUSD",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_NZDUSD = "Condition NZDUSD NO TRADE";}

//-------------------------------   
         if (gv_audjpy > 0 && gvta_audjpy > 0)
         {
         Cond_AUDJPY = "Condition AUDJPY BUY";
         CloseOrderCheck("AUDJPY",OP_SELL,Buylots, slipageOrder);
         ManageBuy("AUDJPY",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_audjpy < 0 && gvta_audjpy < 0)
         {
         Cond_AUDJPY = "Condition AUDJPY SELL";
         CloseOrderCheck("AUDJPY",OP_BUY,Buylots, slipageOrder);
         ManageSell("AUDJPY",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_AUDJPY = "Condition AUDJPY NO TRADE";}

//-------------------------------   
         if (gv_nzdjpy > 0 && gvta_nzdjpy > 0)
         {
         Cond_NZDJPY = "Condition NZDJPY BUY";
         CloseOrderCheck("NZDJPY",OP_SELL,Buylots, slipageOrder);
         ManageBuy("NZDJPY",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_nzdjpy < 0 && gvta_nzdjpy < 0)
         {
         Cond_NZDJPY = "Condition NZDJPY SELL";
         CloseOrderCheck("NZDJPY",OP_BUY,Buylots, slipageOrder);
         ManageSell("NZDJPY",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_NZDJPY = "Condition NZDJPY NO TRADE";}

//-------------------------------   
         if (gv_cadjpy > 0 && gvta_cadjpy > 0)
         {
         Cond_CADJPY = "Condition CADJPY BUY";
         CloseOrderCheck("CADJPY",OP_SELL,Buylots, slipageOrder);
         ManageBuy("CADJPY",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_cadjpy < 0 && gvta_cadjpy < 0)
         {
         Cond_CADJPY = "Condition CADJPY SELL";
         CloseOrderCheck("CADJPY",OP_BUY,Buylots, slipageOrder);
         ManageSell("CADJPY",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_CADJPY = "Condition CADJPY NO TRADE";}
//-------------------------------   
         if (gv_usdcad > 0 && gvta_usdcad > 0)
         {
         Cond_USDCAD = "Condition USDCAD BUY";
         CloseOrderCheck("USDCAD",OP_SELL,Buylots, slipageOrder);
         ManageBuy("USDCAD",OP_BUY,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else if (gv_usdcad < 0 && gvta_usdcad < 0)
         {
         Cond_USDCAD = "Condition USDCAD SELL";
         CloseOrderCheck("USDCAD",OP_BUY,Buylots, slipageOrder);
         ManageSell("USDCAD",OP_SELL,Buylots,takeProfit,_stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         else{
         Cond_USDCAD = "Condition USDCAD NO TRADE";}
         
//=================================================================================================

   Comment (Cond_GBPAUD + "         " + Cond_EURAUD + "          " + Cond_AUDUSD + "            " + Cond_AUDJPY + "\n" +
            Cond_GBPNZD + "         " + Cond_EURNZD + "          " + Cond_NZDUSD + "            " + Cond_NZDJPY + "\n" +
            Cond_GBPCAD + "         " + Cond_EURCAD + "          " + Cond_USDCAD + "            " + Cond_CADJPY + "\n" +
            Cond_GBPUSD + "         " + Cond_EURUSD + "          " + Cond_GBPUSD + "            " + Cond_GBPJPY + "\n" +
            Cond_GBPJPY + "         " + Cond_EURJPY + "          " + Cond_EURUSD + "            " + Cond_EURJPY + "\n"

            );
//----
   return(0);
}


//////////////////////////////////////////////////////////////////////////////////////////////////  

//bool CloseOrderCheck()
void CloseOrderCheck(string symb, int dir, double lt, int slp)

{

    double ask   =MarketInfo(symb,MODE_ASK);
    double bid   =MarketInfo(symb,MODE_BID);

   int total=OpenTradesForMNandPairType(magicNumber, symb);
   for(int cnt=total-1;cnt>=0;cnt--)
    {
      dselect = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(   OrderType()<=OP_SELL                      // check for opened position 
         && OrderSymbol()==symb                   // check for symbol
         && (OrderMagicNumber() == magicNumber||OrderMagicNumber() == 0))        //  my magic number  && manual trades

      {
         if(OrderType()==OP_BUY)   // long position is opened
         {
            // should it be closed?                       
               if(OrderClose(OrderTicket(),OrderLots(),bid,slipageClose,Violet)) // close position
               {
               Alert("X 1-CloseBuy order : ", OrderSymbol(), OrderClosePrice());
               Alert (GetLastError());                      // Error message
               PlaySound("work.wav") ;
                  //return (true);
               }
               //return(false);
         }
         else // go to short position
         {
            // should it be closed?        
               if(OrderClose(OrderTicket(),OrderLots(),ask,slipageClose,Violet)) // close position
               {
               Alert("X 1-CloseSell order : ",  OrderSymbol(), OrderClosePrice());
               Alert (GetLastError());                      // Error message
                PlaySound("work.wav") ;
                  //return (true);  
               }
               //return(false);
         }
      }
   }
   //return (true);
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//bool OpenOrderCheck()

void ManageBuy(string symb,int dir, double lt,double _takeProfit,double stopLoss,int slp,int magic,string com)
{
    double ask   =MarketInfo(symb,MODE_ASK);
    double bid   =MarketInfo(symb,MODE_BID);
    double point =MarketInfo(symb,MODE_POINT);
    double sprd  =MarketInfo(symb,MODE_SPREAD);

   int ticket;
   int total=OpenTradesForMNandPairType(magicNumber, symb);
   
   if(total<BuymaxTrades)
   {
      // check for long position (BUY) possibility
     if(dir == OP_BUY)
      {
         
         if (_stop_loss > 0) stopLoss   = ask-pips2dbl*_stop_loss;   else stopLoss   = 0;
         if (_take_profit>0) takeProfit = ask+pips2dbl*_take_profit; else takeProfit = 0;
         ticket=OrderSend(symb,OP_BUY,Buylots,ask,slipageOrder, stopLoss,takeProfit,"EA Console",magicNumber,0,Green);
         if(ticket>0)
         {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
            {
             //  buyBE=0;
               PlaySound("ok.wav") ;
               Alert("X 1-BUY order opened : ", symb,OrderOpenPrice());
               Alert (GetLastError());                      // Error message
              // return (true);
            }
         }
         else 
         {
         if(OrderSend(symb,OP_BUY,Buylots,ask,slipageOrder, stopLoss,takeProfit,"EA Console",magicNumber,0,Green) < 0) 
         Alert("Error opening position # ", GetLastError());
        // return(0);
//         Alert("Error opening BUY order : ",GetLastError());   
//         return(false);
         }   
      }
    }
}
//-----------------------------------------------------------------------------------------------------------------------
void ManageSell(string symb,int dir,double lt,double _takeProfit,double stopLoss,int slp,int magic,string com)
{
    double ask   =MarketInfo(symb,MODE_ASK);
    double bid   =MarketInfo(symb,MODE_BID);
    double point =MarketInfo(symb,MODE_POINT);
    double sprd  =MarketInfo(symb,MODE_SPREAD);

   int ticket;
   int total=OpenTradesForMNandPairType(magicNumber, symb);

   if(total<SellmaxTrades)
   {
      // check for short position (SELL) possibility
    if(dir == OP_SELL)
      {
         if (_stop_loss > 0) stopLoss   = bid+pips2dbl*_stop_loss;   else stopLoss   = 0;
         if (_take_profit>0) takeProfit = bid-pips2dbl*_take_profit; else takeProfit = 0;
      
         ticket=OrderSend(symb,OP_SELL,Selllots,bid,slipageOrder, stopLoss,takeProfit,"EA Console",magicNumber,0,Red);
         if(ticket>0)
         {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
            { 
             //  sellBE=0;
               PlaySound("ok.wav") ;
               Alert("X 1-SELL order opened : ",symb, OrderOpenPrice());
               Alert (GetLastError());                      // Error message
               //return (true);
            }
         }
         else
         {
         if (OrderSend(symb,OP_SELL,Selllots,bid,slipageOrder, stopLoss,takeProfit,"EA Console",magicNumber,0,Red)<0)
         Alert("Error opening SELL order : ",GetLastError());
         //return (0); 
         } //return (false);
      }
   }
   //return (true);   
}

//////////////////////////////////////////////////////////////////////////////////////////////////
bool TrailingStopCheck()
{  
   double newStopLoss;
   int total=OrdersTotal();
   for(int cnt=total-1;cnt>=0;cnt--)
   {
      dselect = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(   OrderType()<=OP_SELL                      // check for opened position 
         && OrderSymbol()==_symb                   // check for symbol
         && OrderMagicNumber() == magicNumber)        // my magic number
      {
         if(OrderType()==OP_BUY)   // long position is opened
         {
            // should it be modified? 
            newStopLoss = TrailingStopBuy();                      
            if(newStopLoss > 0)
            {
               if(OrderModify(OrderTicket(),OrderOpenPrice(),newStopLoss,OrderTakeProfit(),0,Green)) // modify position
               {
                   PlaySound("work.wav") ;
                   return (true);
               }
               return(false);
            } 
         }
         else // go to short position
         {
            // should it be modified? 
            newStopLoss = TrailingStopSell();        
            if(newStopLoss > 0)
            {
               if(OrderModify(OrderTicket(),OrderOpenPrice(),newStopLoss,OrderTakeProfit(),0,Green)) // modify position
               {
                  PlaySound("work.wav") ;
                  return (true);
               }
               return(false);
            }          
         }
      }
   }
   return (true);
}

//////////////////////////////////////////////////////////////////////////////////////////////////
double TrailingStopBuy()
{
   double newStopLoss;
   double ask   =MarketInfo(_symb,MODE_ASK);

   newStopLoss=ask-_stopLoss;
   if((newStopLoss-trailingStop)>OrderStopLoss())
      return (newStopLoss);
   return (0);
}

//////////////////////////////////////////////////////////////////////////////////////////////////
double TrailingStopSell()
{
   double newStopLoss;
   double bid   =MarketInfo(_symb,MODE_BID);
   
   newStopLoss=bid+_stopLoss;
   if((newStopLoss+trailingStop)<OrderStopLoss())
      return (newStopLoss);

   return (0);
}

//////////////////////////////////////////////////////////////////////////////////////////////////
int OpenTradesForMNandPairType(int iMN, string symb)
{
   int icnt, itotal, retval;

   retval=0;
   itotal=OrdersTotal();

      for(icnt=itotal-1;icnt>=0;icnt--) // for loop
      {
         dselect = OrderSelect(icnt, SELECT_BY_POS, MODE_TRADES);
         // check for opened position, symbol & MagicNumber
         if (OrderSymbol()== symb)
         {
            if (OrderMagicNumber()==iMN) 
               retval++;             
         } // sOrderSymbol
      } // for loop

   return(retval);
}

///////////////////////////////////////////////////////////////////////////////////////////////////



bool IsNewBar()
{
   if( barTime < Time[0]) 
   {
        // we have a new bar opened
      barTime = Time[0];
      return(true);
   }
   return (false);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
bool IsProfitOnBar()
{
   int icnt, itotal;
   itotal=OrdersTotal();
   if(itotal==0)
      return(true);
      
   for(icnt=itotal-1;icnt>=0;icnt--) // for loop
   {
      dselect = OrderSelect(icnt, SELECT_BY_POS, MODE_TRADES);
      // check for opened position, symbol & MagicNumber
      if (OrderSymbol()== _symb && OrderMagicNumber()==magicNumber)
      {
         if (OrderProfit()>0) 
            return(true);             
      } 
   } // for loop 
   return(false);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
bool Crossed_GBPJPY (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: GBPJPY is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 
//-----------------------------
bool Crossed_GBPAUD (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: GBPAUD is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 
//-----------------------------
bool Crossed_GBPNZD (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: GBPNZD is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 
//-----------------------------
bool Crossed_GBPCAD (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: GBPCAD is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 
//----------------------------
bool Crossed_EURJPY (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: EURJPY is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 
//-----------------------------
bool Crossed_EURAUD (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: EURAUD is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 
//---------------------------
bool Crossed_EURNZD (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: EURNZD is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 
//----------------------------
bool Crossed_EURCAD (double line1 , double line2, double line3 ) 
{ 
   static string last_direction = ""; 
   string current_dirction = ""; 

   if(line1>line2 && line1>line3) current_dirction = "up"; 
   if(line1<line2 && line1<line3)current_dirction = "down"; 
   if(current_dirction != last_direction)  
   { 
      Alert("CRROSED: EURCAD is (" + current_dirction + ") now"); 
      last_direction = current_dirction; 
      return (true); 
   } 
   else 
      { 
      return (false); 
      }  
} 


///////////////////////////////////////////////////////////////////////////////////////////////////
/*
bool AllowTradesByTime()
{
   int Current_Time = TimeHour(TimeCurrent());
   if (Start_Time == 0) Start_Time = 24; 
   if (Finish_Time == 0) Finish_Time = 24; 
   if (Current_Time == 0) Current_Time = 24;
      
   if ( Start_Time < Finish_Time )
      if ( (Current_Time < Start_Time) || (Current_Time >= Finish_Time) ) return(false);
      
   if ( Start_Time > Finish_Time )
      if ( (Current_Time < Start_Time) && (Current_Time >= Finish_Time) ) return(false);
      
   return(0);
}
*/

